<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/TypeAnalysis/ConstEvaluator.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/TypeAnalysis/ConstEvaluator.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/TypeAnalysis/ConstEvaluator.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line">#ifndef Synopsis_TypeAnalysis_ConstEvaluator_hh_</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line">#define Synopsis_TypeAnalysis_ConstEvaluator_hh_</span>
<a id="line9"></a><span class="lineno"> 9</span>
<a id="line10"></a><span class="lineno">10</span><span class="line">#include &lt;Synopsis/PTree/Visitor.hh&gt;</span>
<a id="line11"></a><span class="lineno">11</span><span class="line">#include &lt;Synopsis/PTree/Atoms.hh&gt;</span>
<a id="line12"></a><span class="lineno">12</span><span class="line">#include &lt;Synopsis/PTree/Lists.hh&gt;</span>
<a id="line13"></a><span class="lineno">13</span><span class="line">#include &lt;Synopsis/SymbolLookup/Scope.hh&gt;</span>
<a id="line14"></a><span class="lineno">14</span><span class="line">#include &lt;cassert&gt;</span>
<a id="line15"></a><span class="lineno">15</span>
<a id="line16"></a><span class="lineno">16</span><span class="line"><span class="keyword">namespace</span> Synopsis</span>
<a id="line17"></a><span class="lineno">17</span><span class="line">{</span>
<a id="line18"></a><span class="lineno">18</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/TypeAnalysis.html" title="namespace Synopsis::TypeAnalysis">TypeAnalysis</a></span>
<a id="line19"></a><span class="lineno">19</span><span class="line">{</span>
<a id="line20"></a><span class="lineno">20</span>
<a id="line21"></a><span class="lineno">21</span><span class="line"><span class="comment">//. Evaluate the value of a constant expression.</span></span>
<a id="line22"></a><span class="lineno">22</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/TypeAnalysis/ConstEvaluator.html" title="class Synopsis::TypeAnalysis::ConstEvaluator">ConstEvaluator</a> : <span class="keyword">private</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html" title="class Synopsis::PTree::Visitor">PTree::Visitor</a></span>
<a id="line23"></a><span class="lineno">23</span><span class="line">{</span>
<a id="line24"></a><span class="lineno">24</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">  <a href="" title="member function Synopsis::TypeAnalysis::ConstEvaluator::ConstEvaluator(const SymbolLookup::Scope*)">ConstEvaluator</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope const</a> *s) : my_valid(false), my_scope(s) {}</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">  <span class="keyword">bool</span> <a href="" title="member function Synopsis::TypeAnalysis::ConstEvaluator::evaluate(const PTree::Node*,long&amp;)">evaluate</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *node, <span class="keyword">long</span> &amp;value);</span>
<a id="line27"></a><span class="lineno">27</span>
<a id="line28"></a><span class="lineno">28</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::ConstEvaluator::visit(PTree::Literal*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Literal.html" title="class Synopsis::PTree::Literal">PTree::Literal</a> *);</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::ConstEvaluator::visit(PTree::Identifier*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Identifier.html" title="class Synopsis::PTree::Identifier">PTree::Identifier</a> *);</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::ConstEvaluator::visit(PTree::FstyleCastExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/FstyleCastExpr.html" title="class Synopsis::PTree::FstyleCastExpr">PTree::FstyleCastExpr</a> *);</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::ConstEvaluator::visit(PTree::InfixExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/InfixExpr.html" title="class Synopsis::PTree::InfixExpr">PTree::InfixExpr</a> *);</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::ConstEvaluator::visit(PTree::SizeofExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/SizeofExpr.html" title="class Synopsis::PTree::SizeofExpr">PTree::SizeofExpr</a> *);</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::ConstEvaluator::visit(PTree::UnaryExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/UnaryExpr.html" title="class Synopsis::PTree::UnaryExpr">PTree::UnaryExpr</a> *);</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::ConstEvaluator::visit(PTree::CondExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/CondExpr.html" title="class Synopsis::PTree::CondExpr">PTree::CondExpr</a> *);</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::TypeAnalysis::ConstEvaluator::visit(PTree::ParenExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ParenExpr.html" title="class Synopsis::PTree::ParenExpr">PTree::ParenExpr</a> *);</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">  </span>
<a id="line38"></a><span class="lineno">38</span><span class="line">  <span class="keyword">bool</span>                       <a href="../../../Scopes/Synopsis/TypeAnalysis/ConstEvaluator.html#my_valid" title="data member Synopsis::TypeAnalysis::ConstEvaluator::my_valid">my_valid</a>;</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">  <span class="keyword">long</span>                       <a href="../../../Scopes/Synopsis/TypeAnalysis/ConstEvaluator.html#my_value" title="data member Synopsis::TypeAnalysis::ConstEvaluator::my_value">my_value</a>;</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope const</a> *<a href="../../../Scopes/Synopsis/TypeAnalysis/ConstEvaluator.html#my_scope" title="data member Synopsis::TypeAnalysis::ConstEvaluator::my_scope">my_scope</a>;</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">};</span>
<a id="line42"></a><span class="lineno">42</span>
<a id="line43"></a><span class="lineno">43</span><span class="line"><span class="comment">//. Evaluate the value of a constant expression.</span></span>
<a id="line44"></a><span class="lineno">44</span><span class="line"><span class="comment">//. TODO: This may also return the type of the expression...</span></span>
<a id="line45"></a><span class="lineno">45</span><span class="line">inline <span class="keyword">bool</span> <a href="" title="function Synopsis::TypeAnalysis::evaluate_const(const SymbolLookup::Scope*,const PTree::Node*,long&amp;)">evaluate_const</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope const</a> *scope,</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">			   <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *node, <span class="keyword">long</span> &amp;value)</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">{</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">  <span class="keyword">if</span> (!<a href="" title="parameter node">node</a>) <span class="keyword">return</span> false;</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">  <a href="../../../Scopes/Synopsis/TypeAnalysis/ConstEvaluator.html" title="class Synopsis::TypeAnalysis::ConstEvaluator">ConstEvaluator</a> <a href="" title="local variable e">e</a>(scope);</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">  <span class="keyword">return</span> <a href="" title="local variable e">e</a>.<a href="" title="member function Synopsis::TypeAnalysis::ConstEvaluator::evaluate(const PTree::Node*,long&amp;)">evaluate</a>(<a href="" title="parameter node">node</a>, <a href="" title="parameter value">value</a>);</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">}</span>
<a id="line52"></a><span class="lineno">52</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">}</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">}</span>
<a id="line55"></a><span class="lineno">55</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">#endif</span>
<a id="line57"></a><span class="lineno">57</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:02 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
